﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using Interswitchng.CryptoUtil;
using System.Security.Cryptography;
namespace AutopayAutogate
{
    class Utility
    {
        //To generate SecureData
        public static string[] SecureDataGenerator(String PAN, String ExpiryDate, String PIN)
        {
            var secure = Resource1.secure;
            var x509Certificate = new X509Certificate2();
            var password = "kampala";
            x509Certificate.Import(secure, password, X509KeyStorageFlags.Exportable);

            var tupleResult = new SecureUtil().GetSecureAndPindata(PIN, PAN, ExpiryDate, x509Certificate);

            string[] secureList = new string[2];
            String EncryptedData = tupleResult.Item1;
            String EncryptedCardPIN = tupleResult.Item2;

            secureList[0] = EncryptedData;
            secureList[1] = EncryptedCardPIN;

            return secureList;

        }

        //Hash Algorithm
        public static string hashSHA512(string unhashedValue)
        {
            SHA512 shaM = new SHA512Managed();
            byte[] hash =
             shaM.ComputeHash(Encoding.ASCII.GetBytes(unhashedValue));

            StringBuilder stringBuilder = new StringBuilder();
            foreach (byte b in hash)
            {
                stringBuilder.AppendFormat("{0:x2}", b);
            }
            return stringBuilder.ToString();
        }

        //Random Key Generator
        public static string RandomKeyGenerator()
        {
            int maxSize = 10;
            char[] chars = new char[8];
            string a;
            a = "123456";
            chars = a.ToCharArray();
            int size = maxSize;
            byte[] data = new byte[1];
            RNGCryptoServiceProvider crypto = new RNGCryptoServiceProvider();
            crypto.GetNonZeroBytes(data);
            size = maxSize;
            data = new byte[size];
            crypto.GetNonZeroBytes(data);
            StringBuilder result = new StringBuilder(size);
            foreach (byte b in data)
            {
                result.Append(chars[b % (chars.Length - 1)]);
            }
            return result.ToString();
        }


        //File name Generator
        public static string RandomFilenameGenerator()
        {
            int maxSize = 5;
            char[] chars = new char[4];
            string a;
            a = "ABCDEFGHIJKLMNOPQRSTVWYXZ";
            chars = a.ToCharArray();
            int size = maxSize;
            byte[] data = new byte[1];
            RNGCryptoServiceProvider crypto = new RNGCryptoServiceProvider();
            crypto.GetNonZeroBytes(data);
            size = maxSize;
            data = new byte[size];
            crypto.GetNonZeroBytes(data);
            StringBuilder result = new StringBuilder(size);
            foreach (byte b in data)
            {
                result.Append(chars[b % (chars.Length - 1)]);
            }
            return result.ToString();
        }

        //MAC key Generator
        public static string MacKeyGenerator(string terminalId,string  totalBeneficiaryCodes, double totalAmount, string TotalbeneficiaryAccounts) //Secret is optional.This is usually after the TerminalID.
        {
            var ordinaryData = string.Concat(terminalId, totalBeneficiaryCodes, totalAmount, TotalbeneficiaryAccounts);
            byte[] tmp_data = Encoding.ASCII.GetBytes(ordinaryData);
            byte[] tmp_hash = new SHA512Managed().ComputeHash(tmp_data);
            StringBuilder output = new StringBuilder(tmp_hash.Length);
            for (int i = 0; i < tmp_hash.Length; i++)
            {
            output.Append(tmp_hash[i].ToString("X2"));
            }
            return output.ToString();
        }
    }


}
